#!/usr/bin/env python
import gtk, gobject
import gnome.ui
import gtk.glade
import os
from xml.dom.ext.reader.Sax import FromXmlFile
from xml.dom import Node

from movieClass import *
from languageClass import *
from languagesClass import *

from dialog.select import *

class MovieUI:

    def __init__(self):
        self.filename = "noName.xml"
        self.widgetTree = None
	self.languages = []
        self.subtitles = []
        self.genres = ["action","SF","comedie","documentaire","drame","horreur","X","Fiction","enfance","musical"]
        self.on_accept = None
	self.on_cancel = None

        self.widgetTree = gtk.glade.XML("movieinfo.glade")

        destroy_dic = { "on_quit_button_clicked": self.quit_signal_handler,
                        "on_saveAs_button_clicked": self.saveAs_signal_handler,
                        "on_save_button_clicked": self.save_signal_handler,
                        "on_open_button_clicked": self.open_signal_handler,
                        "on_new_button_clicked": self.new_signal_handler,
                        "on_addSubtitleButton_clicked": self.addSubtitle_signal_handler,
                        "on_removeSubtitleButton_clicked": self.removeSubtitle_signal_handler,
                        "on_OKbutton_clicked": self.accept_changes,
                        "on_CANCELbutton_clicked": self.cancel_changes}
        self.widgetTree.signal_autoconnect(destroy_dic)

        ## languages
        ######################
        ## --- ONLY FOR pygtk 2.4
        ## 1. define widgets
        #self.read_languages_from_file("languages.xml")
        #listStore = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_OBJECT)
        #comboBox = gtk.ComboBox(listStore)
        #self.get_widget("table").attach(comboBox,1,2,1,2,gtk.EXPAND,gtk.FILL)
        #comboBox.show()

        ## 2. set display
        #for aLanguage in self.languages:
        #    listStore.append([aLanguage.code, aLanguage])
        #cell = gtk.CellRendererText()
        #combobox.pack_start(cell, gtk.TRUE)
        #combobox.add_attribute(cell, 'text', 0)
        ## --- not finished
        #####################

        ####################
        ## -- FOR pygtk 2.0 to 2.2 
        self.languages = Languages().read_from_file("languages/languages.xml")
        self.languagesEntry = gtk.Combo()
        ## defines border of the widget
        LEFT_ATTACH=1
        RIGHT_ATTACH=2
        TOP_ATTACH=2
        BOTTOM_ATACH=3
        self.get_widget("table").attach(self.languagesEntry,LEFT_ATTACH,RIGHT_ATTACH,TOP_ATTACH,BOTTOM_ATACH,gtk.EXPAND,gtk.FILL)
        self.languagesEntry.show()
        self.languagesEntry.set_popdown_strings(self.languages.all_labels())

        ##-- set subtitles
        subtitlesModel = gtk.ListStore(gobject.TYPE_STRING)
        self.get_widget("subtitlesEntry").set_model(subtitlesModel)
        renderer = gtk.CellRendererText()
        column0 = gtk.TreeViewColumn("label", renderer, text=0)
        self.get_widget("subtitlesEntry").append_column(column0)
        #####################


    
    def quit_signal_handler(self,arg):
        gtk.main_quit()
        return True

    def new_signal_handler(self,arg):
        print "not yet implemented"
        return True

    def open_signal_handler(self,arg):
        file_selector = gtk.FileSelection("Open...")
        file_selector.set_select_multiple(False)
        file_selector.complete("*.xml")
        selectedFile = None
        def use_file_selection(button, file_selector):
            selection = file_selector.get_filename()
            if os.path.isdir(selection):
                pass
            else:
                selectedFile = selection
                file_selector.destroy()
            self.filename = selectedFile
            self.update_fields_from(Movie.read_from_file(selectedFile))
            
        def close_file_selection(button, file_selector):
            file_selector.destroy()
            
        file_selector.ok_button.connect("clicked", use_file_selection, file_selector)
        file_selector.cancel_button.connect( 'clicked', close_file_selection, file_selector)
        file_selector.show()
        return True

    def save_signal_handler(self,arg):
        print "not yet implemnted"
        return True

    def saveAs_signal_handler(self,arg):
        print "not yet implemnted"
        return True

    def addSubtitle_signal_handler(self,arg):
        aSelect = Select()
        ## set contents
        listStore = gtk.ListStore(gtk.gdk.Pixbuf, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
        for aLanguage in self.languages.library:
            listStore.append((aLanguage.get_icon(),aLanguage.label,aLanguage))
        col1 = gtk.TreeViewColumn('Flag',gtk.CellRendererPixbuf(),pixbuf=0)
        aSelect.listWidget.append_column(col1)
        col2 = gtk.TreeViewColumn('Language',gtk.CellRendererText(),text=1)
        aSelect.listWidget.append_column(col2)
        aSelect.listWidget.set_model(listStore)
        
        aSelect.on_accept = self.add_subtitle_iter
        aSelect.set_size(180,250)
        return True

    def add_subtitle_iter(self,anIter):
        ## retrieve the language object at position 2
        ## (the pixbuf of the falg is at position 0
        ##   and the label is at position 1)
        return self.add_subtitle(anIter[2])
    
    def add_subtitle(self,aSubtitle):
        return self.add_subtitle_code(aSubtitle.code)
        
    def add_subtitle_code(self,aCode):
        for aSavedCode in self.subtitles:
            if aSavedCode == str(aCode):
                return False
        self.subtitles.append(str(aCode))
        ##-- can close select window
        self.update_subtitles()
        return True

    def removeSubtitle_signal_handler(self,arg):
        tree = self.get_widget("subtitlesEntry")
        treeSelection = tree.get_selection()
        #print treeSelection
        (model, path) = treeSelection.get_selected_rows()
        treeModelRow = tree.get_model()[path[0]]
        selectedSubtitleCode = treeModelRow[0]
        self.subtitles.remove(selectedSubtitleCode)
        self.update_subtitles()
        return True

    def update_subtitles(self):
        view = self.widgetTree.get_widget("subtitlesEntry")
        model = view.get_model()
        model.clear()
        for aSubtitle in self.subtitles:
            iter = model.append()
            model.set(iter, 0, aSubtitle)

    def build_movie_instance(self):
        currentMovie = Movie()
        currentMovie.reference = self.get_widget("referenceEntry").get_text()
        currentMovie.title = self.get_widget("titleEntry").get_text()
        currentMovie.rating.value = self.get_widget("ratingEntry").get_text()
        (currentMovie.rating.min,currentMovie.rating.max) = self.get_widget("ratingEntry").get_range()
        currentMovie.quality.value = self.get_widget("qualityEntry").get_text()
        (currentMovie.quality.min,currentMovie.quality.max) = self.get_widget("qualityEntry").get_range()

        selectedLanguage = self.languagesEntry.entry.get_text()
        currentMovie.language = self.languages.get_with_label(selectedLanguage)

        
        currentMovie.subtitles = self.languages.get_all_languages_with_codes(self.subtitles)
        return currentMovie
    
    def accept_changes(self, arg):
        ##-- try to make accept this movie to the caller
        if self.on_accept is not None:
            if not self.on_accept(self.build_movie_instance()) :
                return
        self.close_window()
        
    def close_window(self):
        self.get_widget("window").destroy()
        
    def cancel_changes(self, arg):
        if self.on_cancel is not None:
            if not self.on_cancel(self.build_movie_instance()) :
                return
        self.close_window()
    
    def get_widget(self,aWidgetId):
        return self.widgetTree.get_widget(aWidgetId)

    def update_fields_from(self,aMovie):
        self.get_widget("referenceEntry").set_text(aMovie.reference)
        self.get_widget("titleEntry").set_text(aMovie.title)

        ## language
        self.languagesEntry.entry.set_text(self.languages.get_with_code(aMovie.language.code).label)
        
        ## rating and quality
        self.get_widget("qualityEntry").set_text(aMovie.quality.value)
        self.get_widget("qualityEntry").set_range(float(aMovie.quality.min),float(aMovie.quality.max))
        self.get_widget("qualityEntry").update()
        self.get_widget("ratingEntry").set_text(aMovie.rating.value)
        self.get_widget("ratingEntry").set_range(float(aMovie.rating.min),float(aMovie.rating.max))
        self.get_widget("ratingEntry").update()

        self.subtitles = []
        for aSubtitle in aMovie.subtitles:
            self.add_subtitle(aSubtitle)
        self.update_subtitles()

    def set_interactive(self, isInteractive):
        if isInteractive:
            self.get_widget("buttons").show()
            self.get_widget("toolbar").hide()
            self.get_widget("menubar").hide()
            self.get_widget("window").resize(237,110)
        else:
            self.get_widget("buttons").hide()
            self.get_widget("toolbar").shiw()
            self.get_widget("menubar").show()
        
def main():
    gtk.main()
    return 0
                                                                                
if __name__ == "__main__":
    aMovieUI = MovieUI()
    main()


